package com.eco.plugin.wink.workflow.controller;

import com.eco.plugin.wink.workflow.db.bean.FormDefEntity;
import com.eco.plugin.wink.workflow.db.bean.FormDetailEntity;
import com.eco.plugin.wink.workflow.db.controller.FormDbController;
import com.eco.plugin.wink.workflow.utils.ResponseUtils;
import com.eco.plugin.wink.workflow.utils.Utils;
import com.fr.decision.webservice.annotation.LoginStatusChecker;
import com.fr.json.JSONObject;
import com.fr.third.springframework.stereotype.Controller;
import com.fr.third.springframework.web.bind.annotation.PostMapping;
import com.fr.third.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

@Controller
@LoginStatusChecker(required = false)
public class FormController {

    /**
     * 获取全部表单
     * @param req
     * @param res
     */
    @PostMapping(value = "/workflow/form/getFormList")
    @ResponseBody
    public void getFormList(HttpServletRequest req,HttpServletResponse res){
        List<FormDefEntity> formDefEntityList = FormDbController.getFormList();
        ResponseUtils.response(res,new JSONObject().put("data",formDefEntityList));
    }

    /**
     * 根据表单id获取字段列表
     * @param req
     * @param res
     */
    @PostMapping(value = "/workflow/form/getFieldByFormId")
    @ResponseBody
    public void getFieldByFormId(HttpServletRequest req,HttpServletResponse res){
        JSONObject param = Utils.getRequestBody(req);
        String formid = param.getString("id");
        List<FormDetailEntity> formDetailEntityList = FormDbController.getFieldByFormId(formid);
        ResponseUtils.response(res,new JSONObject().put("data",formDetailEntityList));
    }
}
