package com.eco.plugin.wink.workflow.db.dao;

import com.eco.plugin.wink.workflow.db.bean.DBLinkEntity;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author wink
 * @version 10.0
 * Created by wink on 2021-12-03
 **/
public class DBLinkDao extends BaseDAO<DBLinkEntity> {

    public DBLinkDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<DBLinkEntity> getEntityClass() {
        return DBLinkEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return DBLinkEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return DBLinkDao.class;
        }
    };

    public void add(DBLinkEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void remove(String id) throws Exception {
        getSession().remove(QueryFactory.create()
                        .addRestriction(RestrictionFactory.eq("id", id)),
                this.getEntityClass());
    }

    public void update(DBLinkEntity entity) throws Exception {
        getSession().merge(entity);
    }

    public List<DBLinkEntity> getAll () throws Exception {
        return getSession().find(QueryFactory.create().addSort("createtime",false),DBLinkEntity.class);
    }
}
