package com.eco.plugin.wink.workflow.db.dao;

import com.eco.plugin.wink.workflow.db.bean.FormDefEntity;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author wink
 * @version 10.0
 * Created by wink on 2021-12-03
 **/
public class FormDefDao extends BaseDAO<FormDefEntity> {

    public FormDefDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<FormDefEntity> getEntityClass() {
        return FormDefEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return FormDefEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return FormDefDao.class;
        }
    };

    public void add(FormDefEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void remove(String id) throws Exception {
        getSession().remove(QueryFactory.create()
                        .addRestriction(RestrictionFactory.eq("id", id)),
                this.getEntityClass());
    }

    public void update(FormDefEntity entity) throws Exception {
        getSession().merge(entity);
    }

    public List<FormDefEntity> getAll () throws Exception {
        return getSession().find(QueryFactory.create().addSort("createtime",false),FormDefEntity.class);
    }

    /**
     * 根据表名获取表单定义对象
     * @param tablename
     * @return
     * @throws Exception
     */
    public FormDefEntity getByTablename(String tablename) throws Exception {
        return getSession().findOne(QueryFactory.create().addRestriction(RestrictionFactory.eq("tablename",tablename)),FormDefEntity.class);
    }
}
