package com.eco.plugin.wink.workflow.db.dao;

import com.eco.plugin.wink.workflow.db.bean.FormDetailEntity;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author wink
 * @version 10.0
 * Created by wink on 2021-12-03
 **/
public class FormFieldDao extends BaseDAO<FormDetailEntity> {

    public FormFieldDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<FormDetailEntity> getEntityClass() {
        return FormDetailEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return FormDetailEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return FormFieldDao.class;
        }
    };

    public void add(FormDetailEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void remove(String id) throws Exception {
        getSession().remove(QueryFactory.create()
                        .addRestriction(RestrictionFactory.eq("id", id)),
                this.getEntityClass());
    }

    public void update(FormDetailEntity entity) throws Exception {
        getSession().merge(entity);
    }

//    public List<FormDetailEntity> getAll () throws Exception {
////        return getSession().find(QueryFactory.create().addSort("createtime",false),FormDetailEntity.class);
//    }

    public List<FormDetailEntity> getFieldById(String formid) throws Exception{
        return getSession().find(QueryFactory.create().addRestriction(RestrictionFactory.eq("formid",formid)).addSort("sort",false),FormDetailEntity.class);
    }
}
