package com.eco.plugin.wink.workflow.db.dao;

import com.eco.plugin.wink.workflow.db.bean.WorkflowDefEntity;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author wink
 * @version 10.0
 * Created by wink on 2021-12-03
 **/
public class WorkflowDefDao extends BaseDAO<WorkflowDefEntity> {

    public WorkflowDefDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<WorkflowDefEntity> getEntityClass() {
        return WorkflowDefEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return WorkflowDefEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return WorkflowDefDao.class;
        }
    };

    public void add(WorkflowDefEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void remove(String id) throws Exception {
        getSession().remove(QueryFactory.create()
                        .addRestriction(RestrictionFactory.eq("id", id)),
                this.getEntityClass());
    }

    public void update(WorkflowDefEntity entity) throws Exception {
        getSession().merge(entity);
    }

    public List<WorkflowDefEntity> getAll () throws Exception {
        return getSession().find(QueryFactory.create().addSort("createtime",false),WorkflowDefEntity.class);
    }

    //根据formid获取流程定义
    public WorkflowDefEntity getByFormid (String formid) throws Exception {
        return getSession().findOne(QueryFactory.create().addRestriction(RestrictionFactory.eq("formid",formid)).addSort("createtime",false),WorkflowDefEntity.class);
    }
}
