package com.eco.plugin.wink.workflow.db.dao;

import com.eco.plugin.wink.workflow.db.bean.WorkflowNodeEntity;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author wink
 * @version 10.0
 * Created by wink on 2021-12-03
 **/
public class WorkflowNodeDao extends BaseDAO<WorkflowNodeEntity> {

    public WorkflowNodeDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<WorkflowNodeEntity> getEntityClass() {
        return WorkflowNodeEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return WorkflowNodeEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return WorkflowNodeDao.class;
        }
    };

    public void add(WorkflowNodeEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void remove(String id) throws Exception {
        getSession().remove(QueryFactory.create()
                        .addRestriction(RestrictionFactory.eq("id", id)),
                this.getEntityClass());
    }

    public void update(WorkflowNodeEntity entity) throws Exception {
        getSession().merge(entity);
    }

    public List<WorkflowNodeEntity> getFieldById(String workflowId) throws Exception{
        return getSession().find(QueryFactory.create().addRestriction(RestrictionFactory.eq("workflowid",workflowId)).addSort("sort",false),WorkflowNodeEntity.class);
    }
}
