package com.eco.plugin.wink.workflow.db.dao;

import com.eco.plugin.wink.workflow.db.bean.WorkflowProcessEntity;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author wink
 * @version 10.0
 * Created by wink on 2021-12-03
 **/
public class WorkflowProcessDao extends BaseDAO<WorkflowProcessEntity> {

    public WorkflowProcessDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<WorkflowProcessEntity> getEntityClass() {
        return WorkflowProcessEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return WorkflowProcessEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return WorkflowProcessDao.class;
        }
    };

    public void add(WorkflowProcessEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void remove(String id) throws Exception {
        getSession().remove(QueryFactory.create()
                        .addRestriction(RestrictionFactory.eq("id", id)),
                this.getEntityClass());
    }

    public void update(WorkflowProcessEntity entity) throws Exception {
        getSession().merge(entity);
    }

    public List<WorkflowProcessEntity> getAll () throws Exception {
        return getSession().find(QueryFactory.create().addSort("createtime",false),WorkflowProcessEntity.class);
    }

    public List<WorkflowProcessEntity> getByFormidAndDataid (String formid,String dataid) throws Exception {
        return getSession().find(QueryFactory.create().addRestriction(RestrictionFactory.eq("formid",formid)).addRestriction(RestrictionFactory.eq("dataid",dataid)).addSort("createtime",false).addSort("sort",false),WorkflowProcessEntity.class);
    }
}
