package com.eco.plugin.wink.workflow.kit;

import com.eco.plugin.wink.workflow.utils.FRUserUtils;
import com.eco.plugin.wink.workflow.utils.FRUtils;
import com.fr.decision.authority.AuthorityContext;
import com.fr.decision.authority.base.constant.SoftRoleType;
import com.fr.decision.authority.base.constant.type.operation.ManualOperationType;
import com.fr.decision.authority.data.CustomRole;
import com.fr.decision.authority.data.User;
import com.fr.decision.base.util.UUIDUtil;
import com.fr.decision.privilege.encrpt.PasswordValidator;
import com.fr.decision.webservice.bean.user.RoleBean;
import com.fr.decision.webservice.bean.user.UserBean;
import com.fr.decision.webservice.exception.general.DuplicatedNameException;
import com.fr.decision.webservice.exception.general.SpecialCharProhibitException;
import com.fr.decision.webservice.exception.login.UserPasswordCanNotEmptyException;
import com.fr.decision.webservice.utils.CharLimitType;
import com.fr.decision.webservice.utils.ControllerFactory;
import com.fr.decision.webservice.utils.UserSourceFactory;
import com.fr.decision.webservice.utils.WebServiceUtils;
import com.fr.decision.webservice.v10.user.CustomRoleService;
import com.fr.decision.webservice.v10.user.UserService;
import com.fr.stable.StringUtils;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.Restriction;
import com.fr.stable.query.restriction.RestrictionFactory;

/**
 * 普通角色Service
 */
public class CustomRoleServiceKit extends CustomRoleService {
    private static volatile CustomRoleServiceKit roleServiceKit = null;

    public CustomRoleServiceKit() {
    }

    public static CustomRoleServiceKit getInstance() {
        if (roleServiceKit == null) {
            roleServiceKit = new CustomRoleServiceKit();
        }
        return roleServiceKit;
    }

    /**
     * 根据角色名获取角色信息
     * @param rolename
     * @return
     * @throws Exception
     */
    public CustomRole getByRolename(String rolename) throws Exception {
        CustomRole customRole = AuthorityContext.getInstance().getCustomRoleController().findOne(QueryFactory.create().addRestriction(RestrictionFactory.eq("name",rolename)));
        return customRole;
    }
}
