
//通用配置-------------------------------------------------------------------------------------------------------------------------
//引入菜单
BI.config("dec.provider.management", function (provider) {
    provider.inject({
        modules: [
            {
                value: "workflow_manage",
                id: "decision-management-workflow-manage",
                text: "流程管理",
                iconCls: "management-data-link-font",
                dev: true
            },
            {
                value: "workflow_manage",
                id: "decision-management-workflow-manage-config",
                pId:"decision-management-workflow-manage",
                text: "初始配置",
                iconCls: "management-data-link-font",
                dev: true
            },
            {
                value: "workflow_database",
                id: "decision-management-workflow-database",
                pId: "decision-management-workflow-manage-config",
                text:"数据库配置",
                iconCls: "management-connection-font",
                cardType:"dec.workflow.database.tab",
                dev: true
            },
            {
                value: "workflow_form",
                id: "decision-management-workflow-form",
                pId: "decision-management-workflow-manage-config",
                text:"表单配置",
                iconCls: "management-connection-font",
                cardType:"dec.workflow.form.tab",
                dev: true
            },
            {
                value: "workflow_config",
                id: "decision-management-workflow-config",
                pId: "decision-management-workflow-manage-config",
                text:"流程配置",
                iconCls: "management-connection-font",
                cardType:"dec.workflow.config.tab",
                dev: true
            },
            {
                value: "workflow_data",
                id: "decision-management-workflow-data",
                pId: "decision-management-workflow-manage",
                text:"数据管理",
                iconCls: "management-connection-font",
                dev: true
            },
            {
                value: "workflow_data_input",
                id: "decision-management-workflow-data_input",
                pId: "decision-management-workflow-data",
                text:"数据录入",
                iconCls: "management-connection-font",
                cardType:"dec.workflow.data.input.tab",
                dev: true
            },
            {
                value: "workflow_data_approval",
                id: "decision-management-workflow-data_approval",
                pId: "decision-management-workflow-data",
                text:"数据审核",
                iconCls: "management-connection-font",
                cardType:"dec.workflow.data.approval.tab",
                dev: true
            }
        ]
    });
});

//数据审核
//配置项
BI.constant("dec.workflow.data.approval.tab.items", [{
    value: 1,
    text: '数据审核',
    card: "dec.workflow.data.approval.panel"
}
])

//标签页
var e = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-register"
    },
    _store: function () {
        return BI.Models.getModel("dec.model.workflow.data.approval.tab")
    },
    watch: {
        activeTab: function (e) {
            this.tabRegister.setSelect(e)
        }
    },
    render: function () {
        tableType = 2;
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-background",
            items: [{
                type: "bi.htape",
                cls: "bi-card bi-border-bottom",
                items: [{
                    el: {
                        type: "dec.line_segment",
                        cls: "dec-font-weight-bold",
                        layouts: [{
                            type: "bi.vertical_adapt"
                        }
                        ],
                        items: BI.map(BI.Constants.getConstant("dec.workflow.data.approval.tab.items"), function (e, t) {
                            return BI.extend({
                                type: "dec.line_segment_button",
                                hgap: 15
                            }, t)
                        }),
                        value: this.model.activeTab,
                        height: 40,
                        listeners: [{
                            eventName: "EVENT_CHANGE",
                            action: function (e) {
                                t.store.openTab(e)
                            }
                        }
                        ]
                    },
                    lgap: 10
                }
                ],
                height: 40
            }, {
                type: "bi.absolute",
                items: [{
                    el: {
                        type: "bi.tab",
                        ref: function () {
                            t.tabRegister = this
                        },
                        single: !0,
                        showIndex: this.model.activeTab,
                        cardCreator: BI.bind(this._createTab, this)
                    },
                    left: 10,
                    right: 10,
                    top: 10,
                    bottom: 10
                }
                ]
            }
            ]
        }
    },
    _createTab: function (i) {
        var e = BI.find(BI.Constants.getConstant("dec.workflow.data.approval.tab.items"), function (e, t) {
            return t.value === i
        });
        return e && BI.isKey(e.card) ? {
                type: e.card
            }
            : {
                type: "bi.label",
                text: i
            }
    }
});
BI.shortcut("dec.workflow.data.approval.tab", e)

//标签页model
var e = BI.inherit(Fix.Model, {
    state: function () {
        return {
            activeTab: DecCst.Web.Register.Tab.VERSION_INFO
        }
    },
    computed: {},
    actions: {
        openTab: function (e) {
            this.model.activeTab = e
        }
    }
});
BI.model("dec.model.workflow.data.approval.tab", e);

//数据录入主面板
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-card",
            rowSize: [30,"fill"],
            rgap:5,
            items: [
                {
                    type:"bi.right_vertical_adapt",
                    cls:"bi-border-bottom",
                    rgap:10,
                    items:[
                        {
                            type: "bi.label",
                            text: "表单:",
                            css:{"font-weight":"bold"}
                        },
                        {
                            type: "dec.workflow.data.formlist",
                            from:"approval",
                            ref:function(ref){
                                t.formlist = ref;
                            },
                            listeners: [{
                                eventName: "EVENT_CHANGE",
                                action: function(formid) {
                                    t.bottom.resetTable(formid);
                                }
                            }]
                        },
                        {
                            type:"bi.button",
                            value:"查看",
                            height:20,
                            width:20,
                            handler:function(){
                                BI.Popovers.removeAll();
                                var id = "弹出层id"+BI.UUID();
                                BI.Popovers.create(id, {
                                    header: "查看",
                                    size: "normal",
                                    logic: {
                                        dynamic: true
                                    },
                                    body: {
                                        type: "dec.workflow.data.show.panel",
                                        formid:t.formlist.getValue(),
                                        dataid:t.bottom.getValue()[0]
                                    }
                                }).show(id);
                            }
                        },
                        {
                            type:"bi.button",
                            value:"审核",
                            height:20,
                            width:20,
                            handler:function(){
                                BI.Popovers.removeAll();
                                var id = "弹出层id"+BI.UUID();
                                BI.Popovers.create(id, {
                                    header: "审核",
                                    size: "small",
                                    logic: {
                                        dynamic: true
                                    },
                                    body: {
                                        type: "dec.workflow.data.approval.comment",
                                        height:120,
                                        ref:function(ref){
                                            t.comment = ref;
                                        }
                                    },
                                    footer:{
                                        type:"bi.right",
                                        rgap:10,
                                        items:[
                                            {
                                                type:"bi.button",
                                                text:"取消",
                                                handler:function(){
                                                    BI.Popovers.remove(id);
                                                }
                                            },
                                            {
                                                type:"bi.button",
                                                text:"确认",
                                                handler:function(){
                                                    var comment = t.comment.getValue();
                                                    approvalFlow(t.formlist.getValue(),t.bottom.getValue()[0],comment);
                                                    BI.Popovers.remove(id);
                                                    t.bottom.initData();
                                                }
                                            },
                                        ]
                                    }
                                }).show(id);
                            }
                        },
                        // {
                        //     type:"bi.button",
                        //     value:"退回",
                        //     height:20,
                        //     width:20,
                        //     handler:function(){
                        //         approvalFlow(t.formlist.getValue(),t.bottom.getValue()[0]);
                        //     }
                        // }
                    ]
                },
                {
                    type:"dec.workflow.data.input.bottom",
                    cls:"bi-border-top",
                    ref:function(ref){
                        t.bottom = ref;
                    }
                }
            ]
        }
    },
});
BI.shortcut("dec.workflow.data.approval.panel", e);

//审核面板
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            // cls: "bi-background",
            cls: "bi-card",
            rowSize: ["fill"],
            items: [
                {
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.label",
                            text:"审批意见:",
                            rgap:10
                        },
                        {
                            type: "bi.textarea_editor",
                            cls: "bi-border bi-focus-shadow",
                            value:"",
                            width:400,
                            height:100,
                            ref:function(ref){
                                t.textarea = ref;
                            }
                        }
                    ]
                }
            ]
        }
    },
    getValue:function(){
        return this.textarea.getValue();
    }
});
BI.shortcut("dec.workflow.data.approval.comment", e);
//数据录入-------------------------------------------------------------------------------------------------------------------------
//配置项
BI.constant("dec.workflow.data.input.tab.items", [{
    value: 1,
    text: '数据录入',
    card: "dec.workflow.data.input.panel"
}
])
var tableType = "";
//标签页
var e = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-register"
    },
    _store: function () {
        return BI.Models.getModel("dec.model.workflow.data.input.tab")
    },
    watch: {
        activeTab: function (e) {
            this.tabRegister.setSelect(e)
        }
    },
    render: function () {
        tableType = 1;
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-background",
            items: [{
                type: "bi.htape",
                cls: "bi-card bi-border-bottom",
                items: [{
                    el: {
                        type: "dec.line_segment",
                        cls: "dec-font-weight-bold",
                        layouts: [{
                            type: "bi.vertical_adapt"
                        }
                        ],
                        items: BI.map(BI.Constants.getConstant("dec.workflow.data.input.tab.items"), function (e, t) {
                            return BI.extend({
                                type: "dec.line_segment_button",
                                hgap: 15
                            }, t)
                        }),
                        value: this.model.activeTab,
                        height: 40,
                        listeners: [{
                            eventName: "EVENT_CHANGE",
                            action: function (e) {
                                t.store.openTab(e)
                            }
                        }
                        ]
                    },
                    lgap: 10
                }
                ],
                height: 40
            }, {
                type: "bi.absolute",
                items: [{
                    el: {
                        type: "bi.tab",
                        ref: function () {
                            t.tabRegister = this
                        },
                        single: !0,
                        showIndex: this.model.activeTab,
                        cardCreator: BI.bind(this._createTab, this)
                    },
                    left: 10,
                    right: 10,
                    top: 10,
                    bottom: 10
                }
                ]
            }
            ]
        }
    },
    _createTab: function (i) {
        var e = BI.find(BI.Constants.getConstant("dec.workflow.data.input.tab.items"), function (e, t) {
            return t.value === i
        });
        return e && BI.isKey(e.card) ? {
                type: e.card
            }
            : {
                type: "bi.label",
                text: i
            }
    }
});
BI.shortcut("dec.workflow.data.input.tab", e)

//标签页model
var e = BI.inherit(Fix.Model, {
    state: function () {
        return {
            activeTab: DecCst.Web.Register.Tab.VERSION_INFO
        }
    },
    computed: {},
    actions: {
        openTab: function (e) {
            this.model.activeTab = e
        }
    }
});
BI.model("dec.model.workflow.data.input.tab", e);

//数据录入主面板
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-card",
            rowSize: [30,"fill"],
            rgap:5,
            items: [
                {
                    type:"bi.right_vertical_adapt",
                    cls:"bi-border-bottom",
                    rgap:10,
                    items:[
                        {
                            type: "bi.label",
                            text: "表单:",
                            css:{"font-weight":"bold"}
                        },
                        {
                            type: "dec.workflow.data.formlist",
                            from:"input",
                            ref:function(ref){
                                t.formlist = ref;
                            },
                            listeners: [{
                                eventName: "EVENT_CHANGE",
                                action: function(formid) {
                                    t.bottom.resetTable(formid);
                                }
                            }]
                        },
                        {
                            type:"bi.button",
                            value:"发起审核",
                            height:20,
                            width:20,
                            handler:function(){
                                var formid=t.formlist.getValue();
                                var dataid=t.bottom.getValue()[0];
                                var data =getDataById({formid:formid,dataid:dataid});

                                if(data.status != "" && data.status != null && data.status != undefined){
                                    BI.Msg.toast("已发起流程的数据禁止重复发起!")
                                }else{
                                    startFlow(t.formlist.getValue(),t.bottom.getValue()[0]);
                                    t.bottom.initData();
                                }
                            }
                        },
                        {
                            type:"bi.button",
                            value:"新增",
                            height:20,
                            width:20,
                            handler:function(){
                                BI.Popovers.removeAll();
                                var id = "弹出层id"+BI.UUID();
                                BI.Popovers.create(id, {
                                    header: "数据录入",
                                    size: "normal",
                                    logic: {
                                        dynamic: true
                                    },
                                    body: {
                                        type: "dec.workflow.data.input.edit",
                                        from:"add",
                                        ref:function(ref){
                                            t.inputEditPanel = ref;
                                        }
                                    },
                                    footer:{
                                        type:"bi.right",
                                        rgap:10,
                                        items:[
                                            {
                                                type:"bi.button",
                                                text:"取消",
                                                handler:function(){
                                                    BI.Popovers.remove(id);
                                                }
                                            },
                                            {
                                                type:"bi.button",
                                                text:"确认",
                                                handler:function(){
                                                    t.inputEditPanel.save();
                                                    BI.Popovers.remove(id);
                                                    t.bottom.initData();
                                                }
                                            },
                                        ]
                                    }
                                }).show(id);
                            }
                        },{
                            type:"bi.button",
                            value:"删除",
                            height:20,
                            width:20,
                            handler:function(){
                                var formid=t.formlist.getValue();
                                var dataid=t.bottom.getValue()[0];
                                var data =getDataById({formid:formid,dataid:dataid});

                                if(data.status != "" && data.status != null && data.status != undefined){
                                    BI.Msg.toast("发起流程的数据禁止删除!")
                                }else{
                                    deleteData({formid:formid,dataid:dataid});
                                    t.bottom.initData();
                                }
                            }
                        },{
                            type:"bi.button",
                            value:"查看",
                            height:20,
                            width:20,
                            handler:function(){
                                BI.Popovers.removeAll();
                                var id = "弹出层id"+BI.UUID();
                                BI.Popovers.create(id, {
                                    header: "查看",
                                    size: "normal",
                                    logic: {
                                        dynamic: true
                                    },
                                    body: {
                                        type: "bi.vertical",
                                        items:[{
                                            type: "dec.workflow.data.show.panel",
                                            formid:t.formlist.getValue(),
                                            dataid:t.bottom.getValue()[0]
                                        }]

                                    }
                                }).show(id);
                            }
                        }]
                },
                {
                    type:"dec.workflow.data.input.bottom",
                    cls:"bi-border-top",
                    ref:function(ref){
                        t.bottom = ref;
                    }
                }
            ]
        }
    },
});
BI.shortcut("dec.workflow.data.input.panel", e);

//数据查看面板
var e = BI.inherit(BI.Widget, {
    props: {
        formid:"",
        dataid:""
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.left",
            items: this.createItems()
        }
    },
    getItems:function(){
        var formid = this.options.formid;
        return getFieldByFormId(formid);
    },
    createItems:function(){
        var t = this;
        var formid = this.options.formid;
        var dataid = this.options.dataid;
        if(formid == ""){
            return [];
        }
        var items = [];
        var nodeList = this.getItems();
        var data = getDataById({formid:formid,dataid:dataid});
        $.each(nodeList,function(index,item){
            if(item.fieldname != "id"){
                items.push({
                    type:"dec.wink.item",
                    text:item.fielddec,
                    tgap:10,
                    value:data[item.fieldname],
                    disabled:true
                })
            }
        })

        return items;
    }
});
BI.shortcut("dec.workflow.data.show.panel", e);

//数据录入面板
var e = BI.inherit(BI.Widget, {
    props: {
        from:""
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            // cls: "bi-background",
            cls: "bi-card",
            rowSize: [30,"fill"],
            items: [
                {
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.label",
                            value:"表单",
                            textHeight:30,
                            rgap:10
                        },{
                            type: "dec.workflow.data.formlist",
                            ref:function(ref){
                                t.formlist = ref;
                            },
                            listeners: [{
                                eventName: "EVENT_CHANGE",
                                action: function(formid) {
                                    t.fieldPanel.refresh(formid);
                                }
                            }]
                        }
                    ]
                },
                {
                    type:"dec.workflow.data.field.panel",
                    from:this.options.from,
                    tgap:20,
                    ref:function(ref){
                        t.fieldPanel = ref;
                    }
                }
            ]
        }
    },
    getValue:function(){
        var fieldValue =this.fieldPanel.getValue();
        var formid = this.formlist.getValue();
        return {"formid":formid,"field":fieldValue};
    },
    save:function(){
        $.ajax({
            type:"post",
            async:false,
            url:"/webroot/decision/workflow/dataprocess/add",
            xhrFields:{
                withCredentials:true
            },
            contentType:"application/json",
            data:JSON.stringify(this.getValue()),
            success:function(data){
                result = data.data;
            },
            error:function(data){
            }
        })

        return result;
    }
});
BI.shortcut("dec.workflow.data.input.edit", e);

//表单下拉框
//当前选中的表单id
var currentInputFormId = "";
var currentApprovalFormId="";
var e = BI.inherit(BI.Widget, {
    props: {
        from:""
    },
    render: function () {
        var t = this;
        return {
            type: "bi.text_value_combo",
            width: 250,
            allowClear: false,
            height: 24,
            items: this.createItems(),
            ref:function(ref){
                t.combo = ref;
            },
            listeners: [{
                eventName: "EVENT_CHANGE",
                action: function() {
                    currentInputFormId =  t.combo.getValue()[0];
                    t.fireEvent("EVENT_CHANGE", t.combo.getValue()[0]);
                }
            }]
        }
    },
    created:function(){
        this.combo.setValue(currentInputFormId);
    },
    getValue:function(){
        return this.combo.getValue()[0];
    },
    getItems:function(){
        var result = [];
        $.ajax({
            type:"post",
            async:false,
            url:"/webroot/decision/workflow/form/getFormList",
            xhrFields:{
                withCredentials:true
            },
            success:function(data){
                result = data.data;
            },
            error:function(data){
            }
        })

        return result;
    },
    createItems:function(){
        var t = this;
        var formlist = this.getItems();
        var comboList = [];

        $.each(formlist,function(index,item){
            if(index == 0){
                currentInputFormId = item.id;
            }
            var combo = {
                text:item.tablename,
                value:item.id
            }

            comboList.push(combo);
        })

        return comboList;
    },
});
BI.shortcut("dec.workflow.data.formlist", e);

//动态字段面板
var e = BI.inherit(BI.Widget, {
    props: {
        formid:""
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.left",
            cls:"bi-border-top",
            items: this.createItems()
        }
    },
    getItems:function(){
        var formid = this.options.formid;
        return getFieldByFormId(formid);
    },
    createItems:function(){
        var t = this;
        t.reflist = [];
        var formid = this.options.formid;
        if(formid == ""){
            return [];
        }

        var nodeList = this.getItems();
        var items = [];

        $.each(nodeList,function(index,item){
            if(item.fieldname != "id" && item.fieldname != "status" && item.fieldname != "createuser" &&item.fieldname != "createtime" &&item.fieldname != "currentuser"){
                items.push({
                    type:"dec.wink.item",
                    text:item.fielddec,
                    tgap:10,
                    ref:function(ref){
                        t.reflist.push({"field":item.fieldname,"ref":ref})
                    },
                    value:""
                })
            }
        })

        return items;
    },
    refresh:function(formid){
        this.attr("formid",formid);
        this.reset();
    },
    getValue:function(){
        var result = [];
        $.each(this.reflist,function(index,item){
            result.push({"field":item.field,"value":item.ref.getValue()});
        })

        return result;
    }
});
BI.shortcut("dec.workflow.data.field.panel", e);

//数据底部面板
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-background",
            items: [
                {
                    type:"dec.workflow.data.input.bottom.right",
                    ref:function(_ref){
                        t.right = _ref;
                    }
                }
            ]
        }
    },
    resetTable:function(formid){
        this.right.resetTable();
    },
    getValue:function(){
        return this.right.getValue();
    },
    initData:function(){
        this.right.initData();
        this.right.resetTable();
    }
});
BI.shortcut("dec.workflow.data.input.bottom", e);
//数据表格


//底部右侧
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {
        return BI.Models.getModel("dec.model.workflow.data.input.bottom.right")
    },
    childContext: ["userManagementConfigs"],
    watch: {

    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            items: [{
                type: "bi.vtape",
                rowSize: ["fill"],
                cls:"bi-card",
                css:{"font-weight":"bold"},
                items: [
                    {
                        type: "dec.workflow.data.table.panel",
                        ref:function(ref){
                            t.tablepanel = ref;
                        }
                    }]
            }]
        }
    },
    getValue:function(){
        return this.tablepanel.getValue();
    },
    resetTable:function(){
        this.tablepanel.refresh();
    },
    initData:function(){
        this.tablepanel.initData();
    }
});
BI.shortcut("dec.workflow.data.input.bottom.right", e);

/**
 * 底部仓库
 */
var e = BI.inherit(Fix.Model, {
    state: function () {
        var e = BI.Constants.getConstant("dec.constant.user.tabs");
        return {
            activeTab: BI.isNotEmptyArray(e) ? e[0].value : "allUser",
            userManagementConfigs: {
                syncOperationType: {
                    type: DecCst.System.Info.AuthenticType.DEFAULT
                },
                manualOperationType: {
                    type: DecCst.System.Info.AuthenticType.DEFAULT
                }
            }
        }
    },
    childContext: ["userManagementConfigs"],
    computed: {
        tabs: function () {
            return BI.map(BI.Constants.getConstant("dec.constant.user.tabs"), function (e, t) {
                return {
                    text: t.text,
                    value: t.value,
                    selected: 0 === e
                }
            })
        },
        isAdmin: function () {
            return BI.Services.getService("dec.service.user.management").isAdmin()
        }
    },
    actions: {
        getUserConfig: function (e) {
            this.getManagementConfig(e),
                BI.Services.getService("dec.service.user.management").initUserOrganization()
        },
        getManagementConfig: function (t) {
            var i = this;
            Dec.Utils.getUserManagementConfig(function (e) {
                i.model.userManagementConfigs = e.data,
                t && t()
            })
        },
        openTab: function (e) {
            this.model.activeTab = e
        },
        createCard: function (i) {
            var e = BI.find(BI.Constants.getConstant("dec.constant.user.tabs"), function (e, t) {
                return t.value === i
            });
            return e ? BI.extend({
                type: e.cardType
            }, e) : {
                type: "bi.label",
                text: i
            }
        }
    }
});
BI.model("dec.model.workflow.data.input.bottom.right", e);

/**
 * 数据表格
 */
var e = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-user-all bi-card",
    },
    _store: function () {
        return BI.Models.getModel("dec.model.workflow.data.table.panel")
    },
    watch: {
        rows: function (e) {
            this.populate(e)
        },
        allPages: function () {
            this.table.setAllPages(this.model.allPages)
        },
        currentPage: function (e) {
            this.table.setPage(e)
        },
        searching: function (e) {
            this.userSourceRow.setVisible(!e)
        }
    },
    beforeInit: function (e) {
        this.store.initConfigs(e)
    },
    mounted: function () {
        var e = this;
        this.store.updateUserListHeight(this._calculateUserListHeight()),
            BI.Resizers.add(this.getName(), function () {
                e.store.updateUserListHeight(e._calculateUserListHeight())
            })
    },
    render: function () {
        var i = this;
        return {
            type: "bi.vtape",
            hgap: 10,
            items: [ {
                type: "dec.workflow.data.table",
                ref: function (e) {
                    i.table = e
                },
                itemsCreator: function (e, t) {
                    i.store.getUsersByPage(e.page, t)
                },
                perPage: this.model.perPage,
                listeners: [{
                    eventName: "EVENT_DELETE",
                    action: function (e) {
                        i.store.deleteUsers(e)
                    }
                }
                ],
                onEdit: BI.bind(this.store.onEditUser, this.store)
            }]
        }
    },
    refresh:function(){
        this.table.refresh();
        this.initData();
    },
    _calculateUserListHeight: function () {
        return this.element.height() - 40 - 82
    },
    beforeDestroy: function () {
        BI.Resizers.remove(this.getName())
    },
    populate: function (e) {
        this.table.populate(e)
    },
    initData: function () {
        this.store.initData()
    },
    getValue:function(){
        return this.table.getValue();
    }
});

BI.shortcut("dec.workflow.data.table.panel", e);

//数据仓库
var e = BI.inherit(Fix.Model, {
    state: function () {
        return {
            rows: [],
            allCount: 0,
            currentPage: 0,
            isAllChecked: !1,
            sortBy: "userAlias",
            asc: !0,
            filter: {
                searchBy: "",
                keyword: ""
            },
            enable: DecCst.User.Available.ALL,
            syncConfigs: {
                turnOn: !1,
                strategy: DecCst.User.SyncUserStrategy.FULL_COVER
            },
            perPage: 1e3,
            selectedValues: [],
            creationType: DecCst.User.CreationType.ALL
        }
    },
    childContext: ["rows", "currentPage", "allCount", "isAllChecked", "sortBy", "asc", "filter", "enable", "syncConfigs", "perPage", "selectedValues", "creationType"],
    context: ["userManagementConfigs"],
    computed: {
        allPages: function () {
            return Math.ceil(this.model.allCount / this.model.perPage)
        },
        searching: function () {
            return BI.isKey(this.model.filter.keyword)
        }
    },
    watch: {
        // "sortBy || asc": function () {
        //     this.initData()
        // },
        // "filter.keyword || creationType": function () {
        //     this.initData()
        // },
        // enable: function () {
        //     this.initData()
        // },
        perPage: function () {
            this.initData()
        }
    },
    created: function () {
        this._bindEvents()
    },
    destroyed: function () {
        this._releaseEvents()
    },
    actions: {
        initConfigs: function (t) {
            var i = this;
            Dec.Utils.getSynchronizeDatasetConfig(function (e) {
                BI.extend(i.model.syncConfigs, e.data),
                BI.isFunction(t) && t()
            })
        },
        initData: function () {
            var t = this;
            this.resetState();
            var param ={
                page: 1,
                count: this.model.perPage,
                formid:currentInputFormId,
                from:tableType
            };

            var pagedata = getPageData(param);

            t._injectUserAttributes(pagedata.items, function () {
                t.model.allCount = pagedata.total,
                    t.model.currentPage = pagedata.page,
                    t.model.rows = pagedata.items
            })
        },
        getUsersByPage: function (e) {
            var t = this;
            this.resetState();
            var param ={
                page: e,
                count: this.model.perPage,
                formid:currentInputFormId,
                from:tableType

            };
            var pagedata = getPageData(param);

            t._injectUserAttributes(pagedata.items, function () {
                t.model.allCount = pagedata.total,
                    t.model.currentPage = pagedata.page,
                    t.model.rows = t._packageRows(pagedata.items)
            })
        },
        deleteUsers: function (e) {
            var t = this;
            Dec.Utils.deleteUsersByIds(e, function (e) {
                t.onDeleteUsers(e)
            })
        },
        onEditUser: function (i, n) {
            BI.some(this.model.rows, function (e, t) {
                if (t.id === n)
                    return BI.extend(t, i), !0
            }),
                this.model.rows.splice(0, 0)
        },
        onDeleteUsers: function (e) {
            // e.data.count === this.model.rows.length ? this.getUsersByPage(1 === this.model.currentPage ? 1 : this.model.currentPage - 1) : this.getUsersByPage(this.model.currentPage)
        },
        onClearUsers: function () {
            this.model.isAllChecked = !1,
                this.model.selectedValues = [],
                this.model.allCount = 0,
                this.model.rows = [],
                this.model.currentPage = 1,
                this.initData()
        },
        updateUserListHeight: function (e) {
            this.model.perPage = BI.max([2, Math.floor(e / 36)])
        },
        resetState: function () {
            this.model.isAllChecked = !1,
                this.model.selectedValues = []
        },
        changeUserSource: function (e) {
            this.model.creationType = e
        }
    },
    _packageRows: function (e) {
        var n = this;
        return BI.each(e, function (e, t) {
            var i = t.creationType === DecCst.User.CreationType.SYNC;
            t.keyword = n.model.filter.keyword,
                t.limited = BI.Services.getService("dec.service.user.management").isLimitedUser(t),
                t.enableEdit = !i || n.model.syncConfigs.strategy === DecCst.User.SyncUserStrategy.INCREMENTAL_UPDATE,
                t.enableDelete = !i,
                t.roleEditable = !i,
                t.enableCheck = !i && !t.limited,
                t.passwordEditable = i ? n.model.userManagementConfigs.syncOperationType.type === DecCst.System.Info.AuthenticType.DEFAULT : n.model.userManagementConfigs.manualOperationType.type === DecCst.System.Info.AuthenticType.DEFAULT
        }),
            BI.remove(e, function (e, t) {
                return BI.Services.getService("dec.service.user.management").checkAdmin(t)
            }),
            e
    },
    _injectUserAttributes: function (i, e) {
        var n,
            t = BI.Providers.getProvider("dec.provider.all_user").getExtraAttributes();
        BI.isEmptyArray(t) ? e() : (n = BI.after(t.length, e), BI.each(t, function (e, t) {
            t.attributeGetter(i, n)
        }))
    },
    _bindEvents: function () {
        var e = this;
        this.unListen = BI.Services.getService("dec.service.user.all_users").on("EVENT_REFRESH", function () {
            e.initData()
        })
    },
    _releaseEvents: function () {
        this.unListen && this.unListen()
    }
});
BI.model("dec.model.workflow.data.table.panel", e);

//数据表
var o = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-user-table",
        $testId: "dec-user-table",
        columnSize: [50, "fill", 100],
        headerRowSize: 32,
        rowSize: 36,
        pager: {},
        perPage: 10,
        header: [],
        items: [],
        formid:""
    },
    _store: function () {
        return BI.Models.getModel("dec.model.user.all.table")
    },
    watch: {
        isAllChecked: function () {
            this.header.setSelected(this.model.isAllChecked)
        }
    },
    render: function () {
        var i = this,
            t = this.options;
        return {
            type: "bi.vertical",
            items: [{
                type: "dec.workflow.data.table.header",
                ref: function (e) {
                    i.header = e
                },
                columnSize: t.columnSize,
                items: this.createHeaders(),
                height: t.headerRowSize,
                listeners: [{
                    eventName: BI.Controller.EVENT_CHANGE,
                    action: function (e, t) {
                        i.store.handleCheckAll(t)
                    }
                }
                ]
            }, {
                type: "bi.button_group",
                ref: function (e) {
                    i.table = e
                },
                chooseType: 1,
                layouts: [{
                    type: "bi.vertical"
                }
                ],
                items: []
            }, {
                el: {
                    type: "dec.pager",
                    ref: function (e) {
                        i.pager = e
                    },
                    height: 30,
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function () {
                            var e = this.getCurrentPage && this.getCurrentPage();
                            t.itemsCreator({
                                page: e
                            }, function (e) {
                                i.populate(e)
                            })
                        }
                    }
                    ]
                },
                vgap: 10
            }
            ]
        }
    },
    refresh:function(){
        this.attr("formid",currentInputFormId);
        this.reset();
    },
    createHeaders:function(){
        var formid = this.options.formid;
        var result = [];

        if(formid == "" || formid == undefined || formid == null){
            return result;
        }
        var fields =getFieldByFormId(formid);

        $.each(fields,function(index,item){
            if(item.fieldname != "id"){
                result.push({
                    text: item.fielddec,
                    type: "bi.label",
                    width: 1/(fields.length -1).toFixed(2)*1
                })
            }
        })

        return result;
    },
    _formatItems: function (e) {
        var i = this,
            n = this.options;
        return BI.map(e, function (e, t) {
            return {
                type: "dec.workflow.data.table.row",
                id: t.id,
                cls: BI.isOdd(e) ? "odd" : "even",
                userInfo: t,
                columnSize: n.columnSize,
                height: n.rowSize,
                onDelete: function (e) {
                    i.fireEvent(o.EVENT_DELETE, e)
                },
                onEdit: n.onEdit
            }
        })
    },
    setCount: function (e) {
        this.pager.setCount(e),
            this.setAllPages(Math.ceil(e / this.options.perPage))
    },
    setAllPages: function (e) {
        this.pager.setAllPages(e)
    },
    setPage: function (e) {
        this.pager.setPage(e)
    },
    getValue: function () {
        return this.table.getValue()
    },
    empty: function () {
        this.header.setSelected(!1)
    },
    populate: function (e) {
        this.table.populate(this._formatItems(e))
    }
});
o.EVENT_DELETE = "EVENT_DELETE",
    BI.shortcut("dec.workflow.data.table", o);

//数据头
var e = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-user-table-header",
        columnSize: [],
        items: [],
        onSortChange: BI.emptyFn,
        onFilterChange: BI.emptyFn,
        height: 32
    },
    _store: function () {
        return BI.Models.getModel("dec.model.user.all.table.header")
    },
    watch: {
        enableCheck: function (e) {
            this.checkbox.setEnable(e)
        }
    },
    render: function () {
        var e = this.options;
        return {
            type: "bi.htape",
            columnSize: e.columnSize,
            items: this._formatItems(e.items)
        }
    },
    _formatItems: function (e) {
        var t = this,
            i = this.options,
            n = [];
        return n.push(BI.extend({
            type: "bi.center",
            width: 50,
            height: i.height,
            items: [{
                type: "dec.multi.checkbox",
                ref: function (e) {
                    t.checkbox = e
                },
                disabled: !this.model.enableCheck,
                listeners: [{
                    eventName: BI.Controller.EVENT_CHANGE,
                    action: function () {
                        t.fireEvent(BI.Controller.EVENT_CHANGE, arguments)
                    }
                }
                ]
            }
            ]
        })),
            n.push({
                type: "bi.htape",
                items: BI.map(e, function (e, t) {
                    return {
                        el: BI.extend({
                            rgap: 10,
                            type: "bi.label",
                            textAlign: "left"
                        }, t, {
                            width: null
                        }),
                        width: t.width
                    }
                })
            }),
            n
    },
    _createExtraItems: function () {
        var i = [],
            e = BI.Providers.getProvider("dec.provider.all_user").getExtraAttributes();
        return BI.each(e, function (e, t) {
            BI.isKey(t.header) ? i.push({
                type: "bi.label",
                textAlign: "left",
                text: t.header,
                title: t.header,
                width: t.width
            }) : BI.isObject(t.header) ? i.push(BI.extend({
                width: t.width
            }, t.header)) : i.push({
                type: "bi.layout",
                width: t.width
            })
        }),
            i
    },
    setSelected: function (e) {
        this.checkbox.setSelected(e)
    },
    setHalfSelected: function (e) {
        this.checkbox.setHalfSelected(e)
    },
    isHalfSelected: function () {
        return this.checkbox.isHalfSelected()
    },
    isSelected: function () {
        return this.checkbox.isSelected()
    }
});
BI.shortcut("dec.workflow.data.table.header", e);

/**
 * 数据行
 */
var e = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-user-table-row bi-border-bottom",
        columnSize: [50, "fill", 100],
        userInfo: {},
        value: BI.UUID()
    },
    _store: function () {
        return BI.Models.getModel("dec.model.user.all.row", this.options)
    },
    watch: {
        selected: function (e) {
            this.setSelected(e)
        }
    },
    render: function () {
        var e = this.options;
        return {
            type: "bi.htape",
            $testId: "dec-user-table-row",
            $value: e.userInfo.username,
            columnSize: e.columnSize,
            items: this._formatItem(e.userInfo)
        }
    },
    getFieldRow:function(height){
        var result = [];
        var data = this.options.userInfo;
        var fields = getFieldByFormId(data.formid);

        $.each(fields,function(index,item){
            if("id" != item.fieldname){
                var obj ={
                    el: {
                        type: "bi.label",
                        textAlign: "left",
                        text: data[item.fieldname],
                        keyword: data[item.fieldname],
                        title: function () {
                            return data[item.fieldname]
                        },
                        rgap: 10,
                        height: height
                    },
                    width: 1/(fields.length -1).toFixed(2)
                }

                result.push(obj);
            }
        })

        return result;
    },
    _formatItem: function (e) {
        var t = this,
            i = this.options,
            n = [],
            o = this.model.keywordMap;
        return n.push({
            type: "bi.center_adapt",
            width: 50,
            height: i.height,
            items: [{
                type: "bi.checkbox",
                $testId: "dec-user-row-checkbox",
                $value: e.id,
                ref: function (e) {
                    t.checkbox = e
                },
                disabled: false,
                selected: e.selected,
                listeners: [{
                    eventName: "EVENT_CHANGE",
                    action: function () {
                        t.store.changeSelected(this.isSelected())
                    }
                }
                ]
            }
            ]
        }),
            n.push({
                el: {
                    type: "bi.htape",
                    height: i.height,
                    scrollable: !1,
                    disabled: !e.enable,
                    items: this.getFieldRow(t.height)
                }
            }),
            n
    },
    _createExtraItems: function (i) {
        var n = [],
            e = BI.Providers.getProvider("dec.provider.all_user").getExtraAttributes();
        return BI.each(e, function (e, t) {
            BI.isKey(t.column) ? n.push(BI.extend({
                type: t.column,
                width: t.width
            }, i)) : BI.isFunction(t.column) ? n.push(BI.extend({
                width: t.width
            }, t.column(i))) : n.push({
                type: "bi.layout",
                width: t.width
            })
        }),
            n
    },
    isSelected: function () {
        return this.checkbox.isSelected()
    },
    getValue: function () {
        return this.options.userInfo.id
    },
    setSelected: function (e) {
        this.options.userInfo.enableCheck && this.checkbox.setSelected(e)
    }
});
e.EVENT_DELETE = "EVENT_DELETE",
    BI.shortcut("dec.workflow.data.table.row", e);
//数据录入底部-----------------------------------------------------------------------------------------------------------------------

//流程配置-------------------------------------------------------------------------------------------------------------------------
//配置项
BI.constant("dec.workflow.config.tab.items", [{
    value: 1,
    text: '流程配置',
    card: "dec.workflow.config.panel"
}
])

//标签页
var e = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-register"
    },
    _store: function () {
        return BI.Models.getModel("dec.model.workflow.config.tab")
    },
    watch: {
        activeTab: function (e) {
            this.tabRegister.setSelect(e)
        }
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-background",
            items: [{
                type: "bi.htape",
                cls: "bi-card bi-border-bottom",
                items: [{
                    el: {
                        type: "dec.line_segment",
                        cls: "dec-font-weight-bold",
                        layouts: [{
                            type: "bi.vertical_adapt"
                        }
                        ],
                        items: BI.map(BI.Constants.getConstant("dec.workflow.config.tab.items"), function (e, t) {
                            return BI.extend({
                                type: "dec.line_segment_button",
                                hgap: 15
                            }, t)
                        }),
                        value: this.model.activeTab,
                        height: 40,
                        listeners: [{
                            eventName: "EVENT_CHANGE",
                            action: function (e) {
                                t.store.openTab(e)
                            }
                        }
                        ]
                    },
                    lgap: 10
                }
                ],
                height: 40
            }, {
                type: "bi.absolute",
                items: [{
                    el: {
                        type: "bi.tab",
                        ref: function () {
                            t.tabRegister = this
                        },
                        single: !0,
                        showIndex: this.model.activeTab,
                        cardCreator: BI.bind(this._createTab, this)
                    },
                    left: 10,
                    right: 10,
                    top: 10,
                    bottom: 10
                }
                ]
            }
            ]
        }
    },
    _createTab: function (i) {
        var e = BI.find(BI.Constants.getConstant("dec.workflow.config.tab.items"), function (e, t) {
            return t.value === i
        });
        return e && BI.isKey(e.card) ? {
                type: e.card
            }
            : {
                type: "bi.label",
                text: i
            }
    }
});
BI.shortcut("dec.workflow.config.tab", e)

//标签页model
var e = BI.inherit(Fix.Model, {
    state: function () {
        return {
            activeTab: DecCst.Web.Register.Tab.VERSION_INFO
        }
    },
    computed: {},
    actions: {
        openTab: function (e) {
            this.model.activeTab = e
        }
    }
});
BI.model("dec.model.workflow.config.tab", e);

//流程配置主面板
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-card",
            rowSize: [30,"fill"],
            rgap:5,
            items: [
                {
                    type:"bi.right_vertical_adapt",
                    cls:"bi-border-bottom",
                    rgap:10,
                    items:[{
                        type:"bi.button",
                        value:"导入流程",
                        height:20,
                        width:20,
                        handler:function(){
                            BI.Popovers.removeAll();
                            var id = "弹出层id"+BI.UUID();
                            BI.Popovers.create(id, {
                                type: "bi.bar_popover",
                                header: "流程导入",
                                size: "small",
                                logic: {
                                    dynamic: true
                                },
                                body: {
                                    type: "dec.workflow.config.export",
                                    height:120,
                                    ref:function(ref){
                                        t.export = ref;
                                    }
                                },
                                listeners: [{
                                    eventName: "EVENT_CANCEL",
                                    action: function(){
                                        BI.Popovers.remove(id);
                                    }
                                }, {
                                    eventName: "EVENT_CONFIRM",
                                    action: function(){
                                        t.export.save();
                                        BI.Popovers.remove(id);
                                        t.bottom.refresh();
                                    }
                                }]
                            }).show(id);
                        }
                    },
                        // {
                        //     type:"bi.button",
                        //     value:"删除",
                        //     height:20,
                        //     width:20
                        // }
                    ]
                },
                {
                    type:"dec.workflow.config.bottom",
                    cls:"bi-border-top",
                    ref:function(ref){
                        t.bottom = ref;
                    }
                }
            ]
        }
    },
});
BI.shortcut("dec.workflow.config.panel", e);

/**
 * 导入表单面板
 * @type {{}}
 */
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            // cls: "bi-background",
            cls: "bi-card",
            rowSize: ["fill"],
            items: [
                {
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.textarea_editor",
                            cls: "bi-border bi-focus-shadow",
                            value:"",
                            width:400,
                            height:100,
                            ref:function(ref){
                                t.textarea = ref;
                            }
                        }
                    ]
                }
            ]
        }
    },
    getValue:function(){
        return this.textarea.getValue();
    },
    save:function(){
        var text = this.getValue();
        $.ajax({
            type:"post",
            async:false,
            url:"/webroot/decision/workflow/config/importWorkFlow",
            data:JSON.stringify({data:text}),
            xhrFields:{
                withCredentials:true
            },
            contentType:"application/json",
            success:function(data){

            },
            error:function(data){
            }
        })
    }
});
BI.shortcut("dec.workflow.config.export", e);

//表单底部面板
var e = BI.inherit(BI.Widget, {
    props: {
        // baseCls: "dec-register"
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
        this.left.selectFirstTreeNode();
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-background",
            items: [
                {
                    type: "bi.htape",
                    cls: "bi-card",
                    columnSize: [200, "fill"],
                    items: [{
                        type:"dec.workflow.config.bottom.left",
                        ref:function(_ref){
                            t.left = _ref;
                        },
                        listeners: [{
                            eventName: "treeclick",
                            action: function(data) {
                                t.right.refreshConfigPane(data);
                            }
                        }]
                    },{
                        type:"dec.workflow.config.bottom.right",
                        ref:function(_ref){
                            t.right = _ref;
                        },
                        listeners: [{
                            eventName: "EDIT_SAVE",
                            action:function(){
                                t.left.refreshTree();
                                t.right.refreshConfigPane(workflowFirstNode);
                            }
                        }]
                    }]
                }
            ]
        }
    },
    refresh:function(){
        this.left.refreshTree();
    }
});
BI.shortcut("dec.workflow.config.bottom", e);

//流程首节点
var workflowFirstNode = {};

//底部左侧
var e = BI.inherit(BI.Widget, {
    props: {
        // baseCls: "dec-register"
    },
    _store: function () {

    },
    watch: {

    },
    render: function () {
        var t = this;

        return {
            type: "bi.vtape",
            rowSize: ["fill"],
            lgap:10,
            items: [
                {
                    type: "bi.single_level_tree",
                    // width: 250,
                    items: BI.deepClone(this.getItems()),
                    ref: function(_ref) {
                        t.tree = _ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var id = t.tree.getValue()[0];
                            var workflowNode = t.getItemById(id);
                            t.fireEvent("treeclick", workflowNode);
                        }
                    }]
                }
            ]
        }
    },
    getItems:function(){
        var result = [];
        $.ajax({
            type:"post",
            async:false,
            url:"/webroot/decision/workflow/config/getWorkflowDefList",
            xhrFields:{
                withCredentials:true
            },
            success:function(data){
                var workflowArray = data.data;
                $.each(workflowArray,function(index,item){
                    if(index == 0){
                        workflowFirstNode = item;
                    }
                    item.text = item.workflowname;
                    item.value = item.id;
                    result.push(item);
                })
            },
            error:function(data){
            }
        })

        return result;
    },
    getItemById:function(id){
        var result = {};
        $.ajax({
            type: "post",
            async: false,
            url: "/webroot/decision/workflow/config/getNodeByWorkflowId",
            contentType: "application/json",
            xhrFields: {
                withCredentials: true
            },
            data: JSON.stringify({id: id}),
            success: function (data) {
                result = data.data;
            },
            error: function (data) {
            }
        })

        return result;
    },
    selectFirstTreeNode:function(){
        var id = workflowFirstNode.id;
        this.tree.setValue(id);
        var workflow = this.getItemById(id);
        this.fireEvent("treeclick", workflow);
    },
    refreshTree:function(){
        this.tree.populate(BI.deepClone(this.getItems()));
        this.selectFirstTreeNode();
    }
});
BI.shortcut("dec.workflow.config.bottom.left", e);

//底部右侧
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            items: [{
                type: "bi.vtape",
                rowSize: [40,"fill"],
                lgap:10,
                cls:"bi-border-left",
                css:{"font-weight":"bold"},
                items: [
                    {
                        type: "bi.label",
                        text:"",
                        textAlign:"left",
                        ref:function(_ref){
                            t.configPane = _ref;
                        }
                    }]
            }]
        }
    },
    refreshConfigPane:function(data){
        data = this.operatorItem(data);
        this.configPane.setValue(data);
    },
    operatorItem:function(data){
        var result = "";
        var items = [];
        $.each(data,function(index,item){
            var str = item.nodename+"("+item.rolename+")→";
            result += str;
        })

        result+="结束";

        return result;
    }
});
BI.shortcut("dec.workflow.config.bottom.right", e)
//流程配置底部-----------------------------------------------------------------------------------------------------------------------

//表单配置-------------------------------------------------------------------------------------------------------------------------
//配置项
BI.constant("dec.workflow.form.tab.items", [{
    value: 1,
    text: '表单配置',
    card: "dec.workflow.form.panel"
}
])

//标签页
var e = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-register"
    },
    _store: function () {
        return BI.Models.getModel("dec.model.workflow.form.tab")
    },
    watch: {
        activeTab: function (e) {
            this.tabRegister.setSelect(e)
        }
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-background",
            items: [{
                type: "bi.htape",
                cls: "bi-card bi-border-bottom",
                items: [{
                    el: {
                        type: "dec.line_segment",
                        cls: "dec-font-weight-bold",
                        layouts: [{
                            type: "bi.vertical_adapt"
                        }
                        ],
                        items: BI.map(BI.Constants.getConstant("dec.workflow.form.tab.items"), function (e, t) {
                            return BI.extend({
                                type: "dec.line_segment_button",
                                hgap: 15
                            }, t)
                        }),
                        value: this.model.activeTab,
                        height: 40,
                        listeners: [{
                            eventName: "EVENT_CHANGE",
                            action: function (e) {
                                t.store.openTab(e)
                            }
                        }
                        ]
                    },
                    lgap: 10
                }
                ],
                height: 40
            }, {
                type: "bi.absolute",
                items: [{
                    el: {
                        type: "bi.tab",
                        ref: function () {
                            t.tabRegister = this
                        },
                        single: !0,
                        showIndex: this.model.activeTab,
                        cardCreator: BI.bind(this._createTab, this)
                    },
                    left: 10,
                    right: 10,
                    top: 10,
                    bottom: 10
                }
                ]
            }
            ]
        }
    },
    _createTab: function (i) {
        var e = BI.find(BI.Constants.getConstant("dec.workflow.form.tab.items"), function (e, t) {
            return t.value === i
        });
        return e && BI.isKey(e.card) ? {
                type: e.card
            }
            : {
                type: "bi.label",
                text: i
            }
    }
});
BI.shortcut("dec.workflow.form.tab", e)

//标签页model
var e = BI.inherit(Fix.Model, {
    state: function () {
        return {
            activeTab: DecCst.Web.Register.Tab.VERSION_INFO
        }
    },
    computed: {},
    actions: {
        openTab: function (e) {
            this.model.activeTab = e
        }
    }
});
BI.model("dec.model.workflow.form.tab", e);

//表单配置主面板
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-card",
            rowSize: [30,"fill"],
            rgap:5,
            items: [
                {
                    type:"bi.right_vertical_adapt",
                    cls:"bi-border-bottom",
                    rgap:10,
                    items:[{
                        type:"bi.button",
                        value:"导入表单",
                        height:20,
                        width:20,
                        handler:function(){
                            BI.Popovers.removeAll();
                            var id = "弹出层id"+BI.UUID();
                            BI.Popovers.create(id, {
                                // type: "bi.bar_popover",
                                header: "表单导入",
                                size: "small",
                                logic: {
                                    dynamic: true
                                },
                                body: {
                                    type: "bi.vertical",
                                    height:120,
                                    items:[
                                        {
                                            type: "dec.workflow.form.export",
                                            ref:function(ref){
                                                t.export = ref;
                                            }
                                        }
                                    ]

                                },
                                footer:{
                                    type:"bi.right",
                                    rgap:10,
                                    items:[
                                        {
                                            type:"bi.button",
                                            text:"取消",
                                            handler:function(){
                                                BI.Popovers.remove(id);
                                            }
                                        },
                                        {
                                            type:"bi.button",
                                            text:"确认",
                                            handler:function(){
                                                t.export.save();
                                                BI.Popovers.remove(id);
                                                t.bottom.refresh();
                                            }
                                        },
                                    ]
                                }
                            }).show(id);
                        }
                    },
                        // {
                        //     type:"bi.button",
                        //     value:"删除",
                        //     height:20,
                        //     width:20
                        // }
                    ]
                },
                {
                    type:"dec.workflow.form.bottom",
                    cls:"bi-border-top",
                    ref:function(ref){
                        t.bottom = ref;
                    }
                }
            ]
        }
    },
});
BI.shortcut("dec.workflow.form.panel", e);

/**
 * 导入表单面板
 * @type {{}}
 */
//表单配置主面板
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            // cls: "bi-background",
            cls: "bi-card",
            rowSize: ["fill"],
            items: [
                {
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.textarea_editor",
                            cls: "bi-border bi-focus-shadow",
                            value:"",
                            width:400,
                            height:100,
                            ref:function(ref){
                                t.textarea = ref;
                            }
                        }
                    ]
                }
            ]
        }
    },
    getValue:function(){
        return this.textarea.getValue();
    },
    save:function(){
        var text = this.getValue();
        $.ajax({
            type:"post",
            async:false,
            url:"/webroot/decision/workflow/importForm",
            data:JSON.stringify({data:text}),
            xhrFields:{
                withCredentials:true
            },
            contentType:"application/json",
            success:function(data){

            },
            error:function(data){
            }
        })
    }
});
BI.shortcut("dec.workflow.form.export", e);

//表单底部面板
var e = BI.inherit(BI.Widget, {
    props: {
        // baseCls: "dec-register"
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
        this.left.selectFirstTreeNode();
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-background",
            items: [
                {
                    type: "bi.htape",
                    cls: "bi-card",
                    columnSize: [200, "fill"],
                    items: [{
                        type:"dec.workflow.form.bottom.left",
                        ref:function(_ref){
                            t.left = _ref;
                        },
                        listeners: [{
                            eventName: "treeclick",
                            action: function(data) {
                                t.right.refreshConfigPane(data);
                            }
                        }]
                    },{
                        type:"dec.workflow.form.bottom.right",
                        ref:function(_ref){
                            t.right = _ref;
                        }
                    }]
                }
            ]
        }
    },
    refresh:function(){
        this.left.refreshTree();
    }
});
BI.shortcut("dec.workflow.form.bottom", e);

//表单首节点
var formFirstNode = {};

//底部左侧
var e = BI.inherit(BI.Widget, {
    props: {
        // baseCls: "dec-register"
    },
    _store: function () {

    },
    watch: {

    },
    render: function () {
        var t = this;

        return {
            type: "bi.vtape",
            rowSize: ["fill"],
            lgap:10,
            items: [
                {
                    type: "bi.single_level_tree",
                    // width: 250,
                    items: BI.deepClone(this.getItems()),
                    ref: function(_ref) {
                        t.tree = _ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var id = t.tree.getValue()[0];
                            var dblink = t.getItemById(id);
                            t.fireEvent("treeclick", dblink);
                        }
                    }]
                }
            ]
        }
    },
    getItems:function(){
        var result = [];
        $.ajax({
            type:"post",
            async:false,
            url:"/webroot/decision/workflow/form/getFormList",
            xhrFields:{
                withCredentials:true
            },
            success:function(data){
                var dblinkArray = data.data;
                $.each(dblinkArray,function(index,item){
                    if(index == 0){
                        formFirstNode = item;
                    }
                    item.text = item.formname;
                    item.value = item.id;
                    result.push(item);
                })
            },
            error:function(data){
            }
        })

        return result;
    },
    getItemById:function(id){
        return getFieldByFormId(id);
    },
    selectFirstTreeNode:function(){
        var id = formFirstNode.id;
        this.tree.setValue(id);
        var dblink = this.getItemById(id);
        this.fireEvent("treeclick", dblink);
    },
    refreshTree:function(){
        this.tree.populate(BI.deepClone(this.getItems()));
        this.selectFirstTreeNode();
    }
});
BI.shortcut("dec.workflow.form.bottom.left", e);

//底部右侧
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            items: [{
                type: "bi.vtape",
                rowSize: ["fill"],
                lgap:10,
                cls:"bi-border-left",
                items: [
                    {
                        type: "dec.workflow.common.panel.show",
                        itemsValue:[{label:"text",value:"text2"}],
                        ref:function(_ref){
                            t.configPane = _ref;
                        }
                    }]
            }]
        }
    },
    refreshConfigPane:function(data){
        data = this.operatorItem(data);
        this.configPane.refresh(data);
    },
    operatorItem:function(data){
        var items = [];
        $.each(data,function(index,item){
            items.push({"label":item.fieldname,"value":item.fielddec})
        })

        return items;
    }
});
BI.shortcut("dec.workflow.form.bottom.right", e)
//表单底部-----------------------------------------------------------------------------------------------------------------------

//数据库配置-----------------------------------------------------------------------------------------------------------------------
//全局变量
var configLeftTreeFirstNode = {};

//配置项
BI.constant("dec.workflow.main.items", [{
    value: 1,
    text: '数据库配置',
    card: "dec.workflow.database.dbconfig"
}
])

//标签页
var e = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-register"
    },
    _store: function () {
        return BI.Models.getModel("dec.model.workflow.database.tab")
    },
    watch: {
        activeTab: function (e) {
            this.tabRegister.setSelect(e)
        }
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-background",
            items: [{
                type: "bi.htape",
                cls: "bi-card bi-border-bottom",
                items: [{
                    el: {
                        type: "dec.line_segment",
                        cls: "dec-font-weight-bold",
                        layouts: [{
                            type: "bi.vertical_adapt"
                        }
                        ],
                        items: BI.map(BI.Constants.getConstant("dec.workflow.main.items"), function (e, t) {
                            return BI.extend({
                                type: "dec.line_segment_button",
                                hgap: 15
                            }, t)
                        }),
                        value: this.model.activeTab,
                        height: 40,
                        listeners: [{
                            eventName: "EVENT_CHANGE",
                            action: function (e) {
                                t.store.openTab(e)
                            }
                        }
                        ]
                    },
                    lgap: 10
                }
                ],
                height: 40
            }, {
                type: "bi.absolute",
                items: [{
                    el: {
                        type: "bi.tab",
                        ref: function () {
                            t.tabRegister = this
                        },
                        single: !0,
                        showIndex: this.model.activeTab,
                        cardCreator: BI.bind(this._createTab, this)
                    },
                    left: 10,
                    right: 10,
                    top: 10,
                    bottom: 10
                }
                ]
            }
            ]
        }
    },
    _createTab: function (i) {
        var e = BI.find(BI.Constants.getConstant("dec.workflow.main.items"), function (e, t) {
            return t.value === i
        });
        return e && BI.isKey(e.card) ? {
                type: e.card
            }
            : {
                type: "bi.label",
                text: i
            }
    }
});
BI.shortcut("dec.workflow.database.tab", e)

//数据库配置数据
var e = BI.inherit(Fix.Model, {
    state: function () {
        return {
            activeTab: DecCst.Web.Register.Tab.VERSION_INFO
        }
    },
    computed: {},
    actions: {
        openTab: function (e) {
            this.model.activeTab = e
        }
    }
});
BI.model("dec.model.workflow.database.tab", e)

//数据库配置左侧面板
var e = BI.inherit(BI.Widget, {
    props: {
        // baseCls: "dec-register"
    },
    _store: function () {

    },
    watch: {

    },
    render: function () {
        var t = this;

        return {
            type: "bi.vtape",
            rowSize: [40,"fill"],
            lgap:10,
            items: [{
                type:"bi.vertical_adapt",
                cls:"bi-border-bottom",
                items:[
                    {
                        type: "bi.button",
                        text: "新建数据库配置",
                        height: 20,
                        width: 110,
                        css:{color:"#fff"},
                        listeners: [{
                            eventName: "EVENT_CHANGE",
                            action: function() {
                                var dblink = getAllDBLink();

                                if(dblink.length != 0){
                                    BI.Msg.toast("只允许添加一个链接!");
                                    return ;
                                }

                                BI.Popovers.removeAll();
                                var id = "workflow"+BI.UUID();
                                BI.Popovers.create(id, {
                                    type: "bi.bar_popover",
                                    header: "新增",
                                    size: "small",
                                    logic: {
                                        dynamic: true
                                    },
                                    body: {
                                        type: "dec.workflow.database.dbconfig.edit.panel",
                                        from:"add",
                                        ref:function(ref){
                                            t.editpanel = ref;
                                        }
                                    },
                                    listeners: [{
                                        eventName: "EVENT_CANCEL",
                                        action: function(){
                                        }
                                    }, {
                                        eventName: "EVENT_CONFIRM",
                                        action: function(){
                                            t.editpanel.save();
                                            t.refreshTree();
                                        }
                                    }]
                                }).show(id);
                            }
                        }]
                    }
                ],
            },
                {
                    type: "bi.single_level_tree",
                    // width: 250,
                    items: BI.deepClone(this.getItems()),
                    ref: function(_ref) {
                        t.tree = _ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var id = t.tree.getValue()[0];
                            var dblink = t.getItemById(id);
                            t.fireEvent("treeclick", dblink);
                        }
                    }]
                }
            ]
        }
    },
    getItems:function(){
        var result = [];
        $.ajax({
            type:"post",
            async:false,
            url:"/webroot/decision/workflow/getAllDbLink",
            xhrFields:{
                withCredentials:true
            },
            success:function(data){
                var dblinkArray = data.data;
                $.each(dblinkArray,function(index,item){
                    if(index == 0){
                        configLeftTreeFirstNode = item;
                    }
                    item.text = item.dbname;
                    item.value = item.id;
                    result.push(item);
                })
            },
            error:function(data){
            }
        })

        return result;
    },
    getItemById:function(id){
        var result = {};
        $.ajax({
            type: "post",
            async: false,
            url: "/webroot/decision/workflow/getDbLinkById",
            contentType: "application/json",
            xhrFields: {
                withCredentials: true
            },
            data: JSON.stringify({id: id}),
            success: function (data) {
                result = data;
            },
            error: function (data) {
            }
        })

        return result;
    },
    selectFirstTreeNode:function(){
        this.tree.setValue(configLeftTreeFirstNode.id);
    },
    refreshTree:function(){
        this.tree.populate(BI.deepClone(this.getItems()));
        this.selectFirstTreeNode();
    }
});
BI.shortcut("dec.workflow.database.dbconfig.left", e)

//数据库配置展示面板
var e = BI.inherit(BI.Widget, {
    props: {
        // baseCls: "dec-register"
    },
    _store: function () {

    },
    watch: {

    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            tgap:10,
            items: [{
                type: "bi.vtape",
                rowSize: [40,40,40,40,40,40,40,40,40,"fill"],
                lgap:10,
                items: [{
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.label",
                            text: "驱动",
                            height: 20,
                            width:100,
                            textAlign:"left",
                            css:{"font-weight":"bold"},
                        },
                        {
                            type: "bi.label",
                            text: configLeftTreeFirstNode.driver,
                            textAlign:"left",
                            height: 20,
                            ref:function(_ref){
                                t.driver = _ref;
                            }
                        }
                    ],
                },{
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.label",
                            text: "数据库名称",
                            width:100,
                            height: 20,
                            textAlign:"left",
                            css:{"font-weight":"bold"},
                        },
                        {
                            type: "bi.label",
                            text: configLeftTreeFirstNode.dbname,
                            height: 20,
                            textAlign:"left",
                            ref:function(_ref){
                                t.dbname = _ref;
                            }
                        }
                    ],
                },{
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.label",
                            text: "主机",
                            height: 20,
                            width:100,
                            textAlign:"left",
                            css:{"font-weight":"bold"},
                        },
                        {
                            type: "bi.label",
                            text: configLeftTreeFirstNode.host,
                            height: 20,
                            textAlign:"left",
                            ref:function(_ref){
                                t.host = _ref;
                            }
                        }
                    ],
                },{
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.label",
                            text: "端口",
                            height: 20,
                            width:100,
                            textAlign:"left",
                            css:{"font-weight":"bold"},
                        },
                        {
                            type: "bi.label",
                            text: configLeftTreeFirstNode.port,
                            height: 20,
                            textAlign:"left",
                            ref:function(_ref){
                                t.port = _ref;
                            }
                        }
                    ],
                },{
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.label",
                            text: "用户名",
                            height: 20,
                            width:100,
                            textAlign:"left",
                            css:{"font-weight":"bold"},
                        },
                        {
                            type: "bi.label",
                            text: configLeftTreeFirstNode.username,
                            height: 20,
                            textAlign:"left",
                            ref:function(_ref){
                                t.username = _ref;
                            }
                        }
                    ],
                },{
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.label",
                            text: "密码",
                            height: 20,
                            width:100,
                            textAlign:"left",
                            css:{"font-weight":"bold"},
                        },
                        {
                            type: "bi.label",
                            text: configLeftTreeFirstNode.password,
                            height: 20,
                            textAlign:"left",
                            ref:function(_ref){
                                t.password = _ref;
                            }
                        }
                    ],
                },{
                    type:"bi.left",
                    items:[
                        {
                            type: "bi.label",
                            text: "编码",
                            height: 20,
                            width:100,
                            textAlign:"left",
                            css:{"font-weight":"bold"},
                        },
                        {
                            type: "bi.label",
                            text: configLeftTreeFirstNode.encode,
                            height: 20,
                            textAlign:"left",
                            ref:function(_ref){
                                t.encode = _ref;
                            }
                        }
                    ],
                },
                    //     {
                    //     type:"bi.left",
                    //     items:[
                    //         {
                    //             type: "bi.label",
                    //             text: "模式",
                    //             height: 20,
                    //             width:100,
                    //             textAlign:"left",
                    //             css:{"font-weight":"bold"},
                    //         },
                    //         {
                    //             type: "bi.label",
                    //             text: configLeftTreeFirstNode.mode,
                    //             height: 20,
                    //             width: 500,
                    //             textAlign:"left",
                    //             ref:function(_ref){
                    //                 t.mode = _ref;
                    //             }
                    //         }
                    //     ],
                    // }
                    ,{
                        type:"bi.left",
                        items:[
                            {
                                type: "bi.label",
                                text: "数据连接url",
                                height: 20,
                                width:100,
                                textAlign:"left",
                                css:{"font-weight":"bold"},
                            },
                            {
                                type: "bi.label",
                                text: configLeftTreeFirstNode.url,
                                height: 20,
                                width: 500,
                                textAlign:"left",
                                ref:function(_ref){
                                    t.url = _ref;
                                }
                            }
                        ],
                    },]
            }]
        }
    },
    refresh:function(data){
        this.driver.setText(data.driver);
        this.dbname.setText(data.dbname);
        this.host.setText(data.host);
        this.port.setText(data.port);
        this.username.setText(data.username);
        this.password.setText(data.password);
        this.encode.setText(data.encode);
        // this.mode.setText(data.mode);
        this.url.setText(data.url);
    }
});
BI.shortcut("dec.workflow.database.dbconfig.panel", e)

//数据库配置右侧面板
var e = BI.inherit(BI.Widget, {
    props: {
    },
    _store: function () {

    },
    watch: {

    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            items: [{
                type: "bi.vtape",
                rowSize: [40,"fill"],
                lgap:10,
                cls:"bi-border-left",
                items: [{
                    type:"bi.vertical_adapt",
                    cls:"bi-border-bottom",
                    horizontalAlign:"right",
                    rgap:10,
                    items:[
                        {
                            type: "bi.button",
                            text: "编辑",
                            height: 20,
                            width: 20,
                            css:{color:"#fff"},
                            listeners: [{
                                eventName: "EVENT_CHANGE",
                                action: function() {
                                    var linkObj = t.linkObj;
                                    if(linkObj == undefined) {
                                        linkObj = configLeftTreeFirstNode;
                                        this.linkObj = configLeftTreeFirstNode;
                                    }
                                    BI.Popovers.removeAll();
                                    var id = "workflow"+BI.UUID();
                                    BI.Popovers.create(id, {
                                        type: "bi.bar_popover",
                                        header: "编辑",
                                        size: "small",
                                        logic: {
                                            dynamic: true
                                        },
                                        body: {
                                            type: "dec.workflow.database.dbconfig.edit.panel",
                                            optype:2,
                                            obj:linkObj,
                                            ref:function(ref){
                                                t.editpanel = ref;
                                            }
                                        },
                                        listeners: [{
                                            eventName: "EVENT_CANCEL",
                                            action: function(){
                                                BI.Popovers.remove(id);
                                            }
                                        }, {
                                            eventName: "EVENT_CONFIRM",
                                            action: function() {
                                                t.editpanel.save();
                                                BI.Popovers.remove(id);
                                                t.fireEvent("EDIT_SAVE", "");
                                                // t.refreshConfigPane({});
                                            }
                                        }]
                                    }).show(id);
                                }
                            }]
                        },
                        {
                            type: "bi.button",
                            text: "删除",
                            height: 20,
                            width: 20,
                            css:{color:"#fff"},
                            listeners: [{
                                eventName: "EVENT_CHANGE",
                                action: function() {
                                    var linkObj = t.linkObj;
                                    if(linkObj == undefined) {
                                        linkObj = configLeftTreeFirstNode;
                                        t.linkObj = configLeftTreeFirstNode;
                                    }
                                    BI.Msg.confirm("提示", "数据库配置删除后不可恢复,确定要删除吗？", function (v) {
                                        if(v){
                                            t.deleteLink(linkObj);
                                            t.fireEvent("EDIT_SAVE","");
                                            t.refreshConfigPane({});
                                        }
                                    });
                                }
                            }]
                        }
                    ],
                },
                    {
                        type: "dec.workflow.database.dbconfig.panel",
                        ref:function(_ref){
                            t.configPane = _ref;
                        }
                    }]
            }]
        }
    },
    refreshConfigPane:function(data){
        this.setLinkObj(data);
        this.configPane.refresh(data);
    },
    setLinkObj:function(data){
        this.linkObj = data;
    },
    deleteLink:function(data){
        $.ajax({
            type:"post",
            async:false,
            url:"/webroot/decision/workflow/deleteDBLink",
            data:JSON.stringify(data),
            xhrFields:{withCredentials: true},
            contentType:"application/json",
            success:function(){

            }
        })
    }
});
BI.shortcut("dec.workflow.database.dbconfig.right", e)

//数据库配置面板
var e = BI.inherit(BI.Widget, {
    props: {
        // baseCls: "dec-register"
    },
    _store: function () {

    },
    watch: {

    },
    mounted: function () {
        this.left.selectFirstTreeNode();
    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            cls: "bi-background",
            items: [
                {
                    type: "bi.htape",
                    cls: "bi-card",
                    columnSize: [200, "fill"],
                    items: [{
                        type:"dec.workflow.database.dbconfig.left",
                        ref:function(_ref){
                            t.left = _ref;
                        },
                        listeners: [{
                            eventName: "treeclick",
                            action: function(data) {
                                t.right.refreshConfigPane(data);
                            }
                        }]
                    },{
                        type:"dec.workflow.database.dbconfig.right",
                        ref:function(_ref){
                            t.right = _ref;
                        },
                        listeners: [{
                            eventName: "EDIT_SAVE",
                            action:function(){
                                t.left.refreshTree();
                                t.right.refreshConfigPane(configLeftTreeFirstNode);
                            }
                        }]
                    }]
                }
            ]
        }
    },

});
BI.shortcut("dec.workflow.database.dbconfig", e)

//数据库新增修改面板
var e = BI.inherit(BI.Widget, {
    props:{
        optype:1,
        obj:{},
    },
    render: function () {
        return {
            type: "bi.vertical",
            vgap:10,
            items:this.createItem(),
        }
    },
    createItem:function(){
        var self = this;

        if(this.options.optype == 1){
            return  [
                {
                    type: "dec.wink.item",
                    text:"驱动",
                    value:"com.mysql.jdbc.Driver",
                    disabled:true,
                    ref:function(ref){
                        self.driver = ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var url = "jdbc:mysql://"+self.host.getValue()+":"+self.port.getValue()+"/"+self.dbname.getValue();
                            self.url.setValue(url);
                        }
                    }]
                },
                {
                    type: "dec.wink.item",
                    text:"数据库名称",
                    ref:function(ref){
                        self.dbname = ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var url = "jdbc:mysql://"+self.host.getValue()+":"+self.port.getValue()+"/"+self.dbname.getValue();
                            self.url.setValue(url);
                        }
                    }]
                },
                {
                    type: "dec.wink.item",
                    text:"主机",
                    ref:function(ref){
                        self.host = ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var url = "jdbc:mysql://"+self.host.getValue()+":"+self.port.getValue()+"/"+self.dbname.getValue();
                            self.url.setValue(url);
                        }
                    }]
                },
                {
                    type: "dec.wink.item",
                    text:"端口",
                    ref:function(ref){
                        self.port = ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var url = "jdbc:mysql://"+self.host.getValue()+":"+self.port.getValue()+"/"+self.dbname.getValue();
                            self.url.setValue(url);
                        }
                    }]
                },
                {
                    type: "dec.wink.item",
                    text:"用户名",
                    ref:function(ref){
                        self.username = ref;
                    },
                },
                {
                    type: "dec.wink.item",
                    text:"密码",
                    inputType:"password",
                    ref:function(ref){
                        self.password = ref;
                    },
                },
                {
                    type: "dec.wink.item",
                    text:"编码",
                    ref:function(ref){
                        self.encode = ref;
                    },
                },
                // {
                //     type: "dec.wink.item",
                //     text:"模式",
                //     ref:function(ref){
                //         self.mode = ref;
                //     },
                // },
                {
                    type: "dec.wink.item",
                    text:"数据链接url",
                    ref:function(ref){
                        self.url = ref;
                    },
                },
            ]
        }else{
            return  [
                {
                    type: "dec.wink.item",
                    text:"驱动",
                    value:"com.mysql.jdbc.Driver",
                    disabled:true,
                    ref:function(ref){
                        self.driver = ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var url = "jdbc:mysql://"+self.host.getValue()+":"+self.port.getValue()+"/"+self.dbname.getValue();
                            self.url.setValue(url);
                        }
                    }]
                },
                {
                    type: "dec.wink.item",
                    text:"数据库名称",
                    value:this.options.obj.dbname,
                    ref:function(ref){
                        self.dbname = ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var url = "jdbc:mysql://"+self.host.getValue()+":"+self.port.getValue()+"/"+self.dbname.getValue();
                            self.url.setValue(url);
                        }
                    }]
                },
                {
                    type: "dec.wink.item",
                    text:"主机",
                    value:this.options.obj.host,
                    ref:function(ref){
                        self.host = ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var url = "jdbc:mysql://"+self.host.getValue()+":"+self.port.getValue()+"/"+self.dbname.getValue();
                            self.url.setValue(url);
                        }
                    }]
                },
                {
                    type: "dec.wink.item",
                    text:"端口",
                    value:this.options.obj.port,
                    ref:function(ref){
                        self.port = ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            var url = "jdbc:mysql://"+self.host.getValue()+":"+self.port.getValue()+"/"+self.dbname.getValue();
                            self.url.setValue(url);
                        }
                    }]
                },
                {
                    type: "dec.wink.item",
                    text:"用户名",
                    value:this.options.obj.username,
                    ref:function(ref){
                        self.username = ref;
                    },
                },
                {
                    type: "dec.wink.item",
                    text:"密码",
                    inputType:"password",
                    value:this.options.obj.password,
                    ref:function(ref){
                        self.password = ref;
                    },
                },
                {
                    type: "dec.wink.item",
                    text:"编码",
                    value:this.options.obj.encode,
                    ref:function(ref){
                        self.encode = ref;
                    },
                },
                // {
                //     type: "dec.wink.item",
                //     text:"模式",
                //     value:this.options.obj.mode,
                //     ref:function(ref){
                //         self.mode = ref;
                //     },
                // },
                {
                    type: "dec.wink.item",
                    text:"数据链接url",
                    value:this.options.obj.url,
                    ref:function(ref){
                        self.url = ref;
                    },
                },
            ]
        }
    },
    getValue:function(){
        return {
            "dbtype":"mysql",
            "driver":this.driver.getValue(),
            "dbname":this.dbname.getValue(),
            "host":this.host.getValue(),
            "port":this.port.getValue(),
            "username":this.username.getValue(),
            "password":this.password.getValue(),
            "encode":this.encode.getValue(),
            // "mode":this.mode.getValue(),
            "url":this.url.getValue(),
            "id":this.options.optype == 1 ? "" : this.options.obj.id
        }
    },
    save:function(){
        $.ajax({
            type:"post",
            async:false,
            url:"/webroot/decision/workflow/addDbLink",
            data:JSON.stringify(this.getValue()),
            xhrFields:{withCredentials: true},
            contentType:"application/json",
            success:function(){

            }
        })
    }
});
BI.shortcut("dec.workflow.database.dbconfig.edit.panel", e)

//通用组件------------------------------------------------------------------------------------------------
//文字+输入框标题
var e = BI.inherit(BI.Widget, {
    props: {
        text: "",
        value:"",
        inputType:"text",
        disabled:false
    },
    render: function () {
        var t = this;
        return {
            type: "bi.left",
            height:25,

            items: [
                {
                    type: "bi.label",
                    text:this.options.text,
                    textHeight:25,
                    textAlign:"left",
                    css:{"font-weight":"bold","color":"black"},
                    width:100,
                    rgap:10
                },{
                    type: "bi.editor",
                    allowBlank: true,
                    value:this.options.value,
                    width: 290,
                    height: 25,
                    cls: "bi-border",
                    inputType:this.options.inputType,
                    disabled:this.options.disabled,
                    validationChecker:function(){
                        return true;
                    },
                    ref:function(ref){
                        t.input = ref;
                    },
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function() {
                            t.fireEvent("EVENT_CHANGE", "");
                        }
                    }]
                }
            ]
        }
    },
    getValue:function(){
        return this.input.getValue();
    },
    setValue:function(value){
        this.input.setValue(value)
    }
});

BI.shortcut("dec.wink.item", e);

//文字+文字展示标题
var e = BI.inherit(BI.Widget, {
    props: {
        item: {},
        clsstr:""
    },
    render: function () {
        var t = this;
        return {
            type:"bi.left",
            cls:this.options.clsstr,
            items:[
                {
                    type: "bi.label",
                    text: this.options.item.label,
                    height: 20,
                    width:100,
                    textHeight:25,
                    textAlign:"left",
                    css:{"font-weight":"bold"},
                },
                {
                    type: "bi.label",
                    text: this.options.item.value,
                    height: 20,
                    width: 500,
                    textHeight:25,
                    textAlign:"left",
                    css:{"font-weight":"bold"},
                }
            ]
        }
    }
});

BI.shortcut("dec.wink.item.label", e);

/**
 * 通用展示面板
 */
var e = BI.inherit(BI.Widget, {
    props: {
        itemsValue:[]
    },
    _store: function () {

    },
    watch: {

    },
    render: function () {
        var t = this;
        return {
            type: "bi.vtape",
            tgap:10,
            items: [{
                type: "bi.vtape",
                rowSize: this.createRows(),
                lgap:10,
                items:this.createItems()
            }]
        }
    },
    refresh:function(data){
        this.attr("itemsValue",data);
        this.reset();
    },
    createItems:function(){
        //创建组件
        var items = [
            {
                type:"dec.wink.item.label",
                item:{label:"字段",value:"描述"},
                clsstr:"bi-border-bottom"
            }
        ];

        //this.options.items label,value格式
        $.each(this.options.itemsValue,function(index,item){
            var itemeach = {
                type:"dec.wink.item.label",
                item:item,
            }

            items.push(itemeach)
        })

        return items;
    },
    createRows:function(){
        var row = [25];
        for(var i=0;i<this.options.itemsValue.length;i++){
            row.push(25);
        }

        row.push("fill");
        return row;
    }
});
BI.shortcut("dec.workflow.common.panel.show", e)

//--------------------------------------------通用方法--------------------------------------------
/**
 * 获取分页数据
 * @param param 当前页，页数量，创建时间,from
 */
function getPageData(param){
    var result = {};
    $.ajax({
        type:"post",
        async:false,
        url:"/webroot/decision/workflow/dataprocess/getPageData",
        xhrFields:{
            withCredentials:true
        },
        contentType:"application/json",
        data:JSON.stringify(param),
        success:function(data){
            result = JSON.parse(data.data);
        },
        error:function(data){
        }
    })
    // var result = {
    //     "page": 1,
    //     "count": 11,
    //     "items": [{
    //         "createtime": "2022-09-10 15:53:51",
    //         "count": "2",
    //         "name": "商品1",
    //         "id": "b61a0c50-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }, {
    //         "createtime": "2022-09-10 15:53:58",
    //         "count": "2",
    //         "name": "商品2",
    //         "id": "ba096dcb-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }, {
    //         "createtime": "2022-09-10 15:54:05",
    //         "count": "2",
    //         "name": "商品3",
    //         "id": "be526d44-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }, {
    //         "createtime": "2022-09-10 15:54:10",
    //         "count": "2",
    //         "name": "商品4",
    //         "id": "c0e8765b-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }, {
    //         "createtime": "2022-09-10 15:54:47",
    //         "count": "2",
    //         "name": "商品5",
    //         "id": "d75f0383-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }, {
    //         "createtime": "2022-09-10 15:54:47",
    //         "count": "2",
    //         "name": "商品6",
    //         "id": "d75fb12e-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }, {
    //         "createtime": "2022-09-10 15:54:47",
    //         "count": "2",
    //         "name": "商品7",
    //         "id": "d75ff4b2-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }, {
    //         "createtime": "2022-09-10 15:54:47",
    //         "count": "2",
    //         "name": "商品8",
    //         "id": "d7603382-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }, {
    //         "createtime": "2022-09-10 15:54:47",
    //         "count": "2",
    //         "name": "商品9",
    //         "id": "d7606096-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }, {
    //         "createtime": "2022-09-10 15:54:47",
    //         "count": "2",
    //         "name": "商品10",
    //         "id": "d7609c30-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }, {
    //         "createtime": "2022-09-10 15:54:47",
    //         "count": "2",
    //         "name": "商品11",
    //         "id": "d760ddd1-30dd-11ed-b4b5-00ff9a8ba50c",
    //         "createuser": "xiamaofa",
    //         "status": ""
    //     }],
    //     "total": 11
    // }
    return result;
}

//开始流程
function startFlow(formid,dataid){
    var result = {};

    $.ajax({
        type:"post",
        async:false,
        url:"/webroot/decision/workflow/process/start",
        xhrFields:{
            withCredentials:true
        },
        contentType:"application/json",
        data:JSON.stringify({formid:formid,dataid:dataid}),
        success:function(data){
            result = data.data;
        },
        error:function(data){
        }
    })

    return result;
}

//审核流程
function approvalFlow(formid,dataid,comment){
    var result = {};

    $.ajax({
        type:"post",
        async:false,
        url:"/webroot/decision/workflow/process/approve",
        xhrFields:{
            withCredentials:true
        },
        contentType:"application/json",
        data:JSON.stringify({formid:formid,dataid:dataid,comment:comment}),
        success:function(data){
            result = data.data;
        },
        error:function(data){
        }
    })

    return result;
}
//根据表单id获取字段
function getFieldByFormId(formid){
    var formid = formid;
    var result = [];
    $.ajax({
        type:"post",
        async:false,
        url:"/webroot/decision/workflow/form/getFieldByFormId",
        xhrFields:{
            withCredentials:true
        },
        contentType:"application/json",
        data:JSON.stringify({id:formid}),
        success:function(data){
            result = data.data;
        },
        error:function(data){
        }
    })

    return result;
}

//获取数据
function getDataById(param){
    var result = {};

    $.ajax({
        type:"post",
        async:false,
        url:"/webroot/decision/workflow/dataprocess/getData",
        xhrFields:{
            withCredentials:true
        },
        contentType:"application/json",
        data:JSON.stringify(param),
        success:function(data){
            result = data;
        },
        error:function(data){
        }
    })

    return result;
}

//删除数据
function deleteData(param){
    var data = {};

    $.ajax({
        type:"post",
        async:false,
        url:"/webroot/decision/workflow/dataprocess/delete",
        xhrFields:{
            withCredentials:true
        },
        contentType:"application/json",
        data:JSON.stringify(param),
        success:function(data){
            data = data.data;
        },
        error:function(data){
        }
    })

    return data;
}

//获取所有数据库链接
function getAllDBLink(){
    var result = [];
    $.ajax({
        type:"post",
        async:false,
        url:"/webroot/decision/workflow/getAllDbLink",
        xhrFields:{
            withCredentials:true
        },
        success:function(data){
            var dblinkArray = data.data;
            $.each(dblinkArray,function(index,item){
                if(index == 0){
                    configLeftTreeFirstNode = item;
                }
                item.text = item.dbname;
                item.value = item.id;
                result.push(item);
            })
        },
        error:function(data){
        }
    })

    return result;
}